/*
cl mpd2f.c /O2 /D_UNICODE /DUNICODE /I ../plugin


MusicPlayer 2.xxxvOCwavt@Cɏo͂B

ver
0.1	 : 
0.2	 : Tv𐳂oĂȂoOCB
0.3  : VvOC`ɑΉ
0.4  : floato
0.5  : \ς
0.6  : wavwb_oOC
0.8  : unicodeΉ
*/

#define VERSION_STR L"Ver.0.8 Unicode"

#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <fcntl.h>
#include <wchar.h>
#include <locale.h>

#include "mpp.h"

#pragma pack(push,1)
//wavt@C̃wb_
typedef struct{
	char RIFF[4];//"RIFF"
	DWORD bytes;//(t@C̃oCg)-8
	char WAVE[4];// "WAVE" 
	char fmt[4];// "fmt "
	DWORD siz_wf;//PCMWAVEFORMAT\̂̃oCg=16
	//PCMWAVEFORMAT\
	WORD wFormatTag; //ʂ1
	WORD nChannels; //`l
	DWORD nSamplesPerSec; //TvO[g
	DWORD nAvgBytesPerSec; //PbԂ̃oCg
	WORD nBlockAlign;  //1TvɕKvȃoCg ch * bits/8
	WORD wBitsPerSample;//ʎqrbg
	char data[4];//"data"
	DWORD pcmbytes;//g`f[^̃oCg
} WAVHEADER;
#pragma pack(pop)

typedef __declspec(dllimport) int (_stdcall *tMusicPlayer2Modules)(DECODER_FUNC *);

static void f32clip(float *f, int s)
{
	while (s--) {
		if (f[s] > 1.0) {
			f[s] = 1.0;
		} else if (f[s] < -1.0) {
			f[s] = -1.0;
		}
	}
	
	return ;
}


//t@CfɑΉvOCTADLLnhpdfplugpathƂɕԂB
HMODULE LoadPlugin(wchar_t *f, DECODER_FUNC *pdf, wchar_t *plugpath)
{
	HMODULE  hDLL;
	wchar_t ext[300];
	HANDLE hFind;
	WIN32_FIND_DATA wfd;
	wchar_t findpath[300], fpath[300], dllpath[300];
	tMusicPlayer2Modules MusicPlayer2Modules;
	wchar_t *p;
	wchar_t xext[300];
	
	_wsplitpath(f, NULL, NULL, NULL, ext);
	if (ext[0] == 0) return NULL;
	CharLower(ext);
	

	GetModuleFileName(GetModuleHandle(0), fpath, 300);
	p = wcsrchr(fpath, L'\\');
	if (p) *p = 0;
	
	//vOCpXdllTĊJB
	swprintf(findpath, 300, L"%ls\\plugin\\*.dll", fpath);
	
	hFind = FindFirstFile(findpath, &wfd);
	if (hFind == INVALID_HANDLE_VALUE) return NULL;
	do {
		if (wfd.cFileName[0] == L'.' && (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) continue;
		swprintf(dllpath, 300, L"%ls\\plugin\\%ls", fpath, wfd.cFileName);
		
		hDLL = LoadLibrary(dllpath);
		if (hDLL == NULL) continue;
		
		MusicPlayer2Modules = (tMusicPlayer2Modules)GetProcAddress(hDLL, "MusicPlayer2Modules");
		if (MusicPlayer2Modules == NULL) {
			FreeLibrary(hDLL);
			continue;
		}
		
		if (MusicPlayer2Modules(pdf) == 0) {
			FreeLibrary(hDLL);
			continue;
		}

		wcscpy(xext, pdf->GetPluginExt());
		CharLower(xext);
		if (wcsstr(xext, ext)) {
			if (plugpath) wcscpy(plugpath, wfd.cFileName);
			//fprintf(stderr, "KvOC>%s\n", wfd.cFileName);
			FindClose(hFind);
			return hDLL;
		}
		
		FreeLibrary(hDLL);
	} while (FindNextFile(hFind, &wfd));

	FindClose(hFind);
	return NULL;
}

//vOCTAΉgqstderrɗ񋓂BvOC̐ԂB
int showpluginlist(void)
{
	HMODULE  hDLL;
	HANDLE hFind;
	WIN32_FIND_DATA wfd;
	wchar_t findpath[300], fpath[300], dllpath[300];
	tMusicPlayer2Modules MusicPlayer2Modules;
	wchar_t *p;
	DECODER_FUNC df;
	int cnt = 0;
	GetModuleFileName(GetModuleHandle(0), fpath, 300);
	p = wcsrchr(fpath, L'\\');
	if (p) *p = 0;
	
	//vOCpXdllTĊJB
	swprintf(findpath, 300, L"%ls\\plugin\\*.dll", fpath);

	hFind = FindFirstFile(findpath, &wfd);
	if (hFind == INVALID_HANDLE_VALUE) return 0;
	do {
		if (wfd.cFileName[0] == L'.' && (wfd.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)) continue;
		swprintf(dllpath, 300, L"%ls\\plugin\\%ls", fpath, wfd.cFileName);
		
		hDLL = LoadLibrary(dllpath);
		if (hDLL == NULL) continue;
		
		MusicPlayer2Modules = (tMusicPlayer2Modules)GetProcAddress(hDLL, "MusicPlayer2Modules");
		if (MusicPlayer2Modules == NULL) {
			FreeLibrary(hDLL);
			continue;
		}
		
		if (MusicPlayer2Modules(&df) == 0) {
			FreeLibrary(hDLL);
			continue;
		}
		cnt++;
		if (cnt == 1) fwprintf(stderr, L"vOC>Ήgq\n"); 
		fwprintf(stderr, L"[%d]%ls>%ls\n", cnt, wfd.cFileName, df.GetPluginExt());
		FreeLibrary(hDLL);
	} while (FindNextFile(hFind, &wfd));
	FindClose(hFind);
	
	
	return cnt;
}



int DecodeToFile(wchar_t *infile, wchar_t *outfile, int wantfloat)
{
	HMODULE  hDLL;
	WAVHEADER wh;
	DECODER_FUNC df;
	DECODER_INFO di;
	FILE *fp = NULL;
	char *buf;
	unsigned siz;
	unsigned read;
	unsigned pflag;
	wchar_t plugname[666];
	
	if (infile == NULL || outfile == NULL) return FALSE;
	
	if ((hDLL = LoadPlugin(infile, &df, plugname)) == NULL) {
		fwprintf(stderr, L"KvOC܂B");
		return FALSE;
	}
	
	if (wcscmp(outfile, L"-") == 0) {
		_setmode(_fileno(stdout), _O_BINARY);
		fp = stdout;
	} else {
		fp = _wfopen(outfile, L"wb");
		if (fp == NULL) {
			fwprintf(stderr, L"o̓t@CG[\n");
			goto ERR;
		}
	}
	
	di.bps = wantfloat ? -32 : 0;
	
	if (df.open(infile, &di) == FALSE) {
		fwprintf(stderr, L"vOCI[vG[\n");
		goto ERR;
	}
	
	//f[^
	if (di.bufsiz) {
		buf = malloc(di.bufsiz);
		if (buf == NULL) {
			df.close(&di);
			fwprintf(stderr, L"obt@mۃG[\n");
			goto ERR;
		}
	}
	
	fwprintf(stderr, L"KvOC>%ls\nTv>%ls\n", plugname, df.GetPluginDescription());
	fwprintf(stderr, L"o̓tH[}bg=%dhz, %dch, %d bit\n\n", di.rate, di.ch, abs(di.bps));
	
	fwprintf(stderr, L"fR[h %ls>%ls\n", infile, outfile);
	
	
	//TCY0wavwb_
	siz = 0;
	wh.pcmbytes = siz;
	memcpy(wh.RIFF , "RIFF" , 4);
	wh.bytes = wh.pcmbytes + 44 - 8;
	memcpy(wh.WAVE , "WAVE", 4); 
	memcpy(wh.fmt , "fmt ", 4);
	wh.siz_wf = 16;
	wh.wFormatTag = (di.bps > 0 ? WAVE_FORMAT_PCM : WAVE_FORMAT_IEEE_FLOAT);
	wh.nChannels = (unsigned short) di.ch;    //`l
	wh.nSamplesPerSec = di.rate;    //W{g
	wh.wBitsPerSample = abs(di.bps);    //ʎqrbg
	wh.nBlockAlign = wh.nChannels * wh.wBitsPerSample/8;
	wh.nAvgBytesPerSec = wh.nSamplesPerSec * wh.nBlockAlign;
	wh.pcmbytes = siz;//TCY0ɂĂ
	memcpy(wh.data , "data", 4);
	
	fwrite(&wh, 1, sizeof(WAVHEADER), fp);

	do {
		read = df.read(buf, &di, &pflag);
		
		if (!di.bufsiz) {
			read = di.pcmsize;
			buf = di.pcmdata;
		}
		siz += read;
		if (di.bps < 0) f32clip((float*)buf, read/sizeof(float));
		fwrite(buf, 1, read, fp);

		fwprintf(stderr, L"fR[h>%d bytes\r", siz);
	} while (pflag == 0);
	
	//wavwb_
	if (fp != stdout) {
		wh.bytes = siz + 44 - 8;
		wh.pcmbytes = siz;
		fseek(fp, 0, SEEK_SET);
		fwrite(&wh,44,1,fp);
		fclose(fp);
	}
	
	fwprintf(stderr, L"\n\n");
	
	df.close(&di);
	if (di.bufsiz) free(buf);
	FreeLibrary(hDLL);

	return TRUE;

ERR:
	if (fp != NULL && fp != stdout) {
		fclose(fp);
		_wremove(outfile);
	}
	if (hDLL) FreeLibrary(hDLL);
	fwprintf(stderr, L"\nG[IłB\n");
	return FALSE;

}

void usage(void)
{
	fwprintf(stderr, L"mpd2f %ls\ng:mpd2f [-f] ̓t@C [owavt@C] \n\n", VERSION_STR);
	fwprintf(stderr, L"\t-f:floato͂v\n");
	fwprintf(stderr, L"\towavt@C-w肷stdoutɏo\n");
	
	if (showpluginlist() == 0) fwprintf(stderr, L"\n[G[]FΉvOC܂B\n"); 

}

int wmain(int argc, wchar_t **argv)
{
	wchar_t in[300] = {0}, out[300] = {0};
	int f = 0;
	int i;
	
	setlocale(LC_ALL, "");	
	if (argc == 1 || argc > 4) {
		usage();
		return 1;
	}
	for (i=1; i<argc; i++) {
		if (argv[i][0] == L'-' || argv[i][0] == L'/' ) {
			switch (towlower(argv[i][1])) {
				case 0:
				out[0] = L'-';
				break;
				
				case L'f':
				f = 1;
				break;
				case L'h':
				usage();
				return 1;
				break;
			}
			continue;
		}
		
		if (in[0] == 0) {
			wcscpy(in, argv[i]);
			continue;
		}
		if (out[0] == 0) {
			wcscpy(out, argv[i]);
			continue;
		}
	}
	
	if (in[0] == 0) return 1;
	if (out[0] == 0) swprintf(out, 300, L"%ls.wav", in);
	
	//printf("%s, %s, %d\n",in, out, f);//test
	if (DecodeToFile(in, out, f)) return 0;
	return 2;
}

